# Copyright (C) 2014-2024 RhodeCode GmbH
#
# This program is free software: you can redistribute it and/or modify
# it under the terms of the GNU Affero General Public License, version 3
# (only), as published by the Free Software Foundation.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU Affero General Public License
# along with this program.  If not, see <http://www.gnu.org/licenses/>.
#
# This program is dual-licensed. If you wish to learn more about the
# RhodeCode Enterprise Edition, including its added features, Support services,
# and proprietary license terms, please see https://rhodecode.com/licenses/

"""
HG commit module
"""

import os
import logging

from zope.cachedescriptors.property import Lazy as LazyProperty

from rhodecode.lib.datelib import utcdate_fromtimestamp
from rhodecode.lib.str_utils import safe_bytes, safe_str
from rhodecode.lib.vcs.backends import base
from rhodecode.lib.vcs.exceptions import CommitError
from rhodecode.lib.vcs.nodes import (
    DirNode,
    FileNode,
    NodeKind,
    RootNode,
    SubModuleNode,
    LargeFileNode,
)
from rhodecode.lib.vcs_common import FILEMODE_LINK

log = logging.getLogger(__name__)


class MercurialCommit(base.BaseCommit):
    """
    Represents state of the repository at the single commit.
    """

    _filter_pre_load = [
        # git specific property not supported here
        "_commit",
    ]

    def __init__(self, repository, raw_id, idx, pre_load=None):
        raw_id = safe_str(raw_id)

        self.repository = repository
        self._remote = repository._remote

        self.raw_id = raw_id
        self.idx = idx

        self._set_bulk_properties(pre_load)

        # caches
        self.nodes = {}
        self._path_mode_cache = {}  # path stats cache, e.g filemode etc
        self._path_type_cache = {}  # path type dir/file/link etc cache

    def _set_bulk_properties(self, pre_load):
        if not pre_load:
            return
        pre_load = [entry for entry in pre_load if entry not in self._filter_pre_load]
        if not pre_load:
            return

        result = self._remote.bulk_request(self.raw_id, pre_load)

        for attr, value in result.items():
            if attr in ["author", "message"]:
                value = safe_str(value)
            elif attr in ["branches"]:
                value = list(value)
            elif attr == "affected_files":
                value = list(map(safe_str, value))
            elif attr == "date":
                value = utcdate_fromtimestamp(*value)
            elif attr in ["children", "parents"]:
                value = self._make_commits(value)
            elif attr in ["phase"]:
                value = self._get_phase_text(value)
            self.__dict__[attr] = value

    @LazyProperty
    def tags(self):
        tags = [name for name, commit_id in self.repository.tags.items() if commit_id == self.raw_id]
        return tags

    @LazyProperty
    def branches(self) -> list[str]:
        return self._remote.ctx_branch(self.raw_id)

    @LazyProperty
    def bookmarks(self):
        bookmarks = [name for name, commit_id in self.repository.bookmarks.items() if commit_id == self.raw_id]
        return bookmarks

    @LazyProperty
    def message(self):
        return safe_str(self._remote.ctx_description(self.raw_id))

    @LazyProperty
    def committer(self):
        return safe_str(self.author)

    @LazyProperty
    def author(self):
        return safe_str(self._remote.ctx_user(self.raw_id))

    @LazyProperty
    def date(self):
        return utcdate_fromtimestamp(*self._remote.ctx_date(self.raw_id))

    @LazyProperty
    def status(self):
        """
        Returns modified, added, removed, deleted files for current commit
        """
        modified, added, deleted, *_ = self._remote.ctx_status(self.raw_id)
        return modified, added, deleted

    @LazyProperty
    def id(self):
        if self.last:
            return "tip"
        return self.short_id

    @LazyProperty
    def short_id(self):
        return self.raw_id[:12]

    def _make_commits(self, commit_ids, pre_load=None):
        return [self.repository.get_commit(commit_id=commit_id, pre_load=pre_load) for commit_id in commit_ids]

    @LazyProperty
    def parents(self):
        """
        Returns list of parent commits.
        """
        parents = self._remote.ctx_parents(self.raw_id)
        return self._make_commits(parents)

    def _get_phase_text(self, phase_id):
        return {
            0: "public",
            1: "draft",
            2: "secret",
        }.get(phase_id) or ""

    @LazyProperty
    def phase(self):
        phase_id = self._remote.ctx_phase(self.raw_id)
        phase_text = self._get_phase_text(phase_id)

        return safe_str(phase_text)

    @LazyProperty
    def obsolete(self):
        obsolete = self._remote.ctx_obsolete(self.raw_id)
        return obsolete

    @LazyProperty
    def hidden(self):
        hidden = self._remote.ctx_hidden(self.raw_id)
        return hidden

    @LazyProperty
    def children(self):
        """
        Returns list of child commits.
        """
        children = self._remote.ctx_children(self.raw_id)
        return self._make_commits(children)

    def _get_kind(self, path):
        path = self._fix_path(path)
        path_type = self._get_path_type(path)
        return path_type

    def _assert_is_path(self, path) -> str | bytes:
        path = self._fix_path(path)

        if self._get_kind(path) != NodeKind.FILE:
            raise CommitError(f"File at path={path} does not exist for commit {self.raw_id}")

        return path

    def get_file_mode(self, path: bytes):
        """
        Returns stat mode of the file at the given ``path``.
        """
        path = self._assert_is_path(path)
        if path not in self._path_mode_cache:
            self._path_mode_cache[path] = self._remote.fctx_flags(self.raw_id, path)

        return self._path_mode_cache[path]

    def is_link(self, path: bytes):
        path = self._assert_is_path(path)
        if path not in self._path_mode_cache:
            self._path_mode_cache[path] = self._remote.fctx_flags(self.raw_id, path)

        return self._path_mode_cache[path] == FILEMODE_LINK

    def is_node_binary(self, path):
        path = self._assert_is_path(path)
        return self._remote.is_binary(self.raw_id, path)

    def node_md5_hash(self, path):
        path = self._assert_is_path(path)
        return self._remote.md5_hash(self.raw_id, path)

    def get_file_content(self, path):
        """
        Returns content of the file at given ``path``.
        """
        path = self._assert_is_path(path)
        return self._remote.fctx_node_data(self.raw_id, path)

    def get_file_content_streamed(self, path):
        path = self._assert_is_path(path)
        stream_method = getattr(self._remote, "stream:fctx_node_data")
        return stream_method(self.raw_id, path)

    def get_file_size(self, path):
        """
        Returns size of the file at given ``path``.
        """
        path = self._assert_is_path(path)
        return self._remote.fctx_size(self.raw_id, path)

    def get_path_history(self, path, limit=None, pre_load=None):
        """
        Returns history of file as reversed list of `MercurialCommit` objects
        for which file at given ``path`` has been modified.
        """
        path = self._assert_is_path(path)
        history = self._remote.node_history(self.raw_id, path, limit)
        return [self.repository.get_commit(commit_id=commit_id, pre_load=pre_load) for commit_id in history]

    def get_file_annotate(self, path, pre_load=None):
        """
        Returns a generator of four element tuples with
            lineno, commit_id, commit lazy loader and line
        """
        result = self._remote.fctx_annotate(self.raw_id, path)

        for ln_no, commit_id, content in result:
            yield (
                ln_no,
                commit_id,
                lambda: self.repository.get_commit(commit_id=commit_id, pre_load=pre_load),
                content,
            )

    def get_nodes(self, path: bytes, pre_load=None):
        """
        Returns combined ``DirNode`` and ``FileNode`` objects list representing
        state of commit at the given ``path``. If node at the given ``path``
        is not instance of ``DirNode``, CommitError would be raised.
        """

        if self._get_kind(path) != NodeKind.DIR:
            raise CommitError(f"Directory does not exist for idx {self.raw_id} at '{path}'")
        path = self._fix_path(path)

        path_nodes = []

        for obj_path, node_kind, flags, pre_load_data in self._remote.get_nodes(self.raw_id, path, pre_load):
            if node_kind is None:
                raise CommitError(f"Requested object type={node_kind} cannot be mapped to a proper type")

            stat_ = flags
            # cache file mode
            if obj_path not in self._path_mode_cache:
                self._path_mode_cache[obj_path] = stat_

            # cache type
            if node_kind not in self._path_type_cache:
                self._path_type_cache[obj_path] = node_kind

            entry = None
            if obj_path in self.nodes:
                entry = self.nodes[obj_path]
            else:
                if node_kind == NodeKind.DIR:
                    entry = DirNode(safe_bytes(obj_path), commit=self)
                elif node_kind == NodeKind.FILE:
                    entry = FileNode(
                        safe_bytes(obj_path), commit=self, mode=stat_, pre_load=pre_load, pre_load_data=pre_load_data
                    )
            if entry:
                self.nodes[obj_path] = entry
                path_nodes.append(entry)

        for obj_path, (location, commit, scm_type) in self._submodules.items():
            if os.path.dirname(obj_path) == path:
                entry = SubModuleNode(obj_path, url=location, commit=commit, alias=scm_type)
                self.nodes[obj_path] = entry
                path_nodes.append(entry)

        path_nodes.sort()
        return path_nodes

    def get_node(self, path: bytes, pre_load=None):
        """
        Returns `Node` object from the given `path`. If there is no node at
        the given `path`, `NodeDoesNotExistError` would be raised.
        """
        path = self._fix_path(path)

        # use cached, if we have one
        if path in self.nodes:
            return self.nodes[path]

        path_type = self._get_path_type(path)
        if path == b"":
            node = RootNode(commit=self)
        else:
            if path_type == NodeKind.DIR:
                node = DirNode(safe_bytes(path), commit=self)
            elif path_type == NodeKind.FILE:
                node = FileNode(safe_bytes(path), commit=self, pre_load=pre_load)
                self._path_mode_cache[path] = node.mode
            else:
                raise self.no_node_at_path(path)
        # cache node
        self.nodes[path] = node
        return self.nodes[path]

    def _get_path_type(self, path: bytes):
        if path in self._path_type_cache:
            return self._path_type_cache[path]

        if path == b"":
            self._path_type_cache[b""] = NodeKind.DIR
            return NodeKind.DIR

        path_type, flags = self._remote.get_path_type(self.raw_id, path)

        if not path_type:
            raise self.no_node_at_path(path)

        self._path_type_cache[path] = path_type
        self._path_mode_cache[path] = flags

        return self._path_type_cache[path]

    def get_largefile_node(self, path: bytes):
        pointer_spec = self._remote.is_large_file(self.raw_id, path)
        if pointer_spec:
            # content of that file regular FileNode is the hash of largefile
            file_id = self.get_file_content(path).strip()

            if self._remote.in_largefiles_store(file_id):
                lf_path = self._remote.store_path(file_id)
                return LargeFileNode(safe_bytes(lf_path), commit=self, org_path=path)
            elif self._remote.in_user_cache(file_id):
                lf_path = self._remote.store_path(file_id)
                self._remote.link(file_id, path)
                return LargeFileNode(safe_bytes(lf_path), commit=self, org_path=path)

    @LazyProperty
    def _submodules(self):
        """
        Returns a dictionary with submodule information from substate file
        of hg repository.
        """
        return self._remote.ctx_substate(self.raw_id)

    @LazyProperty
    def affected_files(self) -> list[bytes]:
        """
        Gets a fast accessible file changes for given commit
        """
        return self._remote.ctx_files(self.raw_id)

    @LazyProperty
    def added_paths(self):
        return [n for n in self.status[1]]

    @LazyProperty
    def changed_paths(self):
        return [n for n in self.status[0]]

    @LazyProperty
    def removed_paths(self):
        return [n for n in self.status[2]]
